clear all
close all
clc


%% Chargement des paramètres
run('Parametres_Maquette.m')

% Chargement du fichier d'essai

% Pour afficher à la fois le modèle et l'expérimental, on peut utilises ici le
% fichier Activite_03_Maquette_Corrige.slx
%fichier_sim = "Activite_01_Maquette";
fichier_sim = 'Activite_03_Maquette_Corrige';

load('theta_b_9V_5sec_exp.mat')

%% Détermination de la sous-matrice jacobienne par rapport à Km
coeff = 1e-6 ;  % Pas de la différence finie
Km = 0.0111 ;   % Valeur initiale de Km
Jeq = 3e-6 ;    % Valeur initiale de Jeq

% Simulation 1
KmPlus = Km*(1+coeff);  % Valeur supérieure
Km = KmPlus ;
a = sim(fichier_sim,'SimulationMode','normal');
b = a.get('simout') ;
sPlus = b.Data ;

% Simulation 2
KmMoins = Km*(1-coeff); % Valeur inférieure
Km = KmMoins ;
a = sim(fichier_sim,'SimulationMode','normal');
b = a.get('simout') ;
sMoins = b.Data ;
JKm = (-sPlus + sMoins) / (2*Km*coeff) ;

%% Détermination de la sous-matrice jacobienne par rapport à Jeq
Km = 0.0111 ;   % Valeur initiale de Km
Jeq = 3e-6 ;    % Valeur initiale de Jeq

JeqPlus = Jeq*(1+coeff);
JeqMoins = Jeq*(1-coeff);

% Simulation 1
Jeq = JeqPlus ;
a = sim(fichier_sim,'SimulationMode','normal');
b = a.get('simout') ;
sPlus = b.Data ;

% Simulation 2
Jeq = JeqMoins ;
a = sim(fichier_sim,'SimulationMode','normal');
b = a.get('simout') ;
sMoins = b.Data ;

JJeq = ( - sPlus + sMoins) / (2*Jeq*coeff) ;

%% Concaténation de la matrice jacobienne
J = [JKm , JJeq] ;
Km = Km;
Jeq = Jeq ;

a = sim(fichier_sim,'SimulationMode','normal');
b = a.get('simout') ;
s = b.Data ;
F = exp.signals.values - s ;   % Résidu (écart entre expérience et simulation)

% Tracé de l'évolution de Km en fonction de l'erreur commise
fig1 = figure() ;
hold on
plot(Km, norm(F), 'o')
drawnow

% Itération 1
X = [Km;Jeq] ;
Xnouveau = X - J\F; 


%% Boucle
compteur = 0 ;
while abs(norm(Xnouveau-X))>1e-5 && compteur < 10 % Conditions de fin
    X = Xnouveau; 
    
    % pour Km
    Km = X(1) ; Jeq = X(2) ; %f = X(3) ;
    KmPlus = Km*(1+coeff);
    KmMoins = Km*(1-coeff);
    Km = KmPlus ;
    a = sim(fichier_sim,'SimulationMode','normal');
    b = a.get('simout') ;
    sPlus = b.Data ;
    Km = KmMoins ;
    a = sim(fichier_sim,'SimulationMode','normal');
    b = a.get('simout') ;
    sMoins = b.Data ;
    JKm = ( - sPlus + sMoins) / (2*Km*coeff) ;
   
    % pour Jeq
    Km = X(1) ; Jeq = X(2) ; %f = X(3) ;
    JeqPlus = Jeq*(1+coeff);
    JeqMoins = Jeq*(1-coeff);
    Jeq = JeqPlus ;
    a = sim(fichier_sim,'SimulationMode','normal');
    b = a.get('simout') ;
    sPlus = b.Data ;
    Jeq = JeqMoins ;
    a = sim(fichier_sim,'SimulationMode','normal');
    b = a.get('simout') ;
    sMoins = b.Data ;
    JJeq = ( - sPlus + sMoins) / (2*Jeq*coeff) ;
        
    % Concaténation de la matrice jacobienne
    J = [JKm , JJeq] ;
    
    Km = X(1) ; Jeq = X(2) ;
    a = sim(fichier_sim,'SimulationMode','normal');
    b = a.get('simout') ;
    s = b.Data ;
    F = exp.signals.values - s ;
   
    plot(Km, norm(F), 'o')
    drawnow

    compteur = compteur + 1 ;
    text = [num2str(compteur),' iterations ', num2str(Km),' = Km.'];
    disp(text)
    
    X = [Km;Jeq] ;
    
    Xnouveau = X - J\F;
    
end
hold off








